diff -urN freebsd8.orig/phpconf/inc/services.inc freebsd8/phpconf/inc/services.inc
--- freebsd8.orig/phpconf/inc/services.inc	2014-02-06 22:57:26.787615013 +0100
+++ freebsd8/phpconf/inc/services.inc	2014-02-14 14:51:05.292597375 +0100
@@ -657,7 +657,16 @@
 				}
 			}
 		}
+		
+		if (isset($config['system']['dnscrypt']['enable'])) {
+			$dnsmasqconf .= "no-resolv\n";
+			$dnsmasqconf .= "server=127.0.0.1#40\n";
 
+			$syscfg = $config['system'];
+			foreach (explode(' ', $syscfg['timeservers']) as $ts)
+				$dnsmasqconf .= "server=/{$ts}/208.67.222.222\n";
+		}
+		
 		if (isset($config['dnsmasq']['allservers'])) {
 			$dnsmasqconf .= "all-servers\n";
 		}
diff -urN freebsd8.orig/phpconf/inc/system.inc freebsd8/phpconf/inc/system.inc
--- freebsd8.orig/phpconf/inc/system.inc	2014-02-06 22:57:26.788615037 +0100
+++ freebsd8/phpconf/inc/system.inc	2014-02-14 14:51:05.291597351 +0100
@@ -568,6 +568,27 @@
 		echo "done\n";
 }
 
+function system_dnscrypt_configure() {
+	global $config, $g;
+
+	killbypid("{$g['varrun_path']}/dnscrypt.pid");
+
+	if (isset($config['system']['dnscrypt']['enable'])) {
+		if ($g['booting'])
+			echo "Starting DNScrypt-proxy... ";
+		sleep(1);
+		$dnscryptdns = "208.67.220.220";
+		$dnscryptport = "53";
+		if ($config['system']['dnscrypt']['dnscryptdns'])
+			$dnscryptdns = $config['system']['dnscrypt']['dnscryptdns'];
+		if ($config['system']['dnscrypt']['dnscryptport'])
+			$dnscryptport = $config['system']['dnscrypt']['dnscryptport'];
+		mwexec("/usr/local/sbin/dnscrypt-proxy -a 127.0.0.1:40 -r {$dnscryptdns}:{$dnscryptport} -d -m0 -p {$g['varrun_path']}/dnscrypt.pid" );
+	}
+
+	return 0;
+}
+
 function system_reboot() {
 	global $g;
 	
diff -urN freebsd8.orig/phpconf/rc.bootup freebsd8/phpconf/rc.bootup
--- freebsd8.orig/phpconf/rc.bootup	2014-02-06 22:57:26.800615322 +0100
+++ freebsd8/phpconf/rc.bootup	2014-02-14 14:51:05.308597768 +0100
@@ -120,6 +120,9 @@
 	/* start dnsmasq service */
 	services_dnsmasq_configure();
 
+	/* start dnscrypt proxy */
+	system_dnscrypt_configure();
+
 	/* start the NTP client */
 	system_ntp_configure();
 	
